

"""########################## Get HHIs (RESERVES)##########################"""


"""## Geographic (layer1)"""

HHI_reserves_countryoforigin = r'./Dataset/S&P/HHI_reserves_geo'

dfs = []

for filename in os.listdir(HHI_reserves_countryoforigin):
    try:
      match = re.search(r'([A-Za-z]+)(?:_LT|\.xlsx)', filename)
      if match:
        x = match.group(1)
      df = pd.read_excel(f'./Dataset/S&P/HHI_reserves_geo/{filename}')
      df['Mineral'] = x
      dfs.append(df)
      print(x)
    except:
      pass
hhi_geo_res = pd.concat(dfs, ignore_index=True)
hhi_geo_res = hhi_geo_res[~hhi_geo_res.Mineral.isin(mineral_filter)]

"""## Legal Origin (layer2)"""

HHI_reserves_countryoforigin = r'./Dataset/S&P/HHI_reservves_countryoforigin_ongoing'
reserves_files = r'./Dataset/S&P/Reserves_clean'

dfs = []

for filename in os.listdir(reserves_files):
    try:
      match = re.search(r'([A-Za-z]+)(?:_LT|\.xlsx)', filename)
      if match:
        x = match.group(1)
      df = pd.read_excel(f'./Dataset/S&P/HHI_reserves_countryoforigin_ongoing/{filename}')
      df['Mineral'] = x
      dfs.append(df)
      print(x)
    except:
      pass
hhi_lo_res = pd.concat(dfs, ignore_index=True)
hhi_lo_res = hhi_lo_res[~hhi_lo_res.Mineral.isin(mineral_filter)]

"""## SOC (layer3)"""

reserves_files = r'./Dataset/S&P/Reserves_clean'
dfs=[]

master_company = pd.read_csv(r"./Dataset/S&P/Company_country/company_master_file.csv")
master_company = master_company.rename(columns={'OWNER_NAME': 'Financial_name', 'OWNER_COUNTRY': 'Country' })

owner_ten = pd.read_excel(r"./Dataset/S&P/Ownership_ten.xls", header=3)
owner_ten = owner_ten.rename(columns={'COMPANY_NAME': 'OWNER_NAME'})

for element in os.listdir(reserves_files):
  try:
    file_path = os.path.join(reserves_files, element)
    z = pd.read_excel(file_path)
    z = pd.merge(z, processed, how='left', on='PROP_ID')
    z = pd.merge(z, coord, on='PROP_ID', how='left')
    z = z.loc[z['year'] == 2022]
    z['Share_1'] = z['value']*(z["OWNER_PCT"]/100)
    z['Share_2'] = z['value']*(z["OWNER_PCT.1"]/100)
    z['Share_3'] = z['value']*(z["OWNER_PCT.2"]/100)
    z['Share_4'] = z['value']*(z["OWNER_PCT.3"]/100)
    z['Share_5'] = z['value']*(z["OWNER_PCT.4"]/100)
    z['Share_6'] = z['value']*(z["OWNER_PCT.5"]/100)
    z['Share_7'] = z['value']*(z["OWNER_PCT.6"]/100)
    z['Share_8'] = z['value']*(z["OWNER_PCT.7"]/100)
    z['Share_9'] = z['value']*(z["OWNER_PCT.8"]/100)
    z['Share_10'] = z['value']*(z["OWNER_PCT.9"]/100)

    df_share_melted = z[['PROP_ID', 'Share_1', 'Share_2',
                'Share_3', 'Share_4', 'Share_5','Share_6', 'Share_7', 'Share_8', 'Share_9', 'Share_10']]
    df_share_melted = pd.melt(df_share_melted, id_vars =['PROP_ID'], value_vars =['Share_1', 'Share_2',
            'Share_3', 'Share_4', 'Share_5','Share_6', 'Share_7', 'Share_8', 'Share_9', 'Share_10'])

    df_share_melted = df_share_melted.dropna(subset=['value'])
    df_share_oc = z[['PROP_ID', 'OWNER_NAME', 'OWNER_NAME.1', 'OWNER_NAME.2', 'OWNER_NAME.3',
            'OWNER_NAME.4',  'OWNER_NAME.5', 'OWNER_NAME.6', 'OWNER_NAME.7',
            'OWNER_NAME.8', 'OWNER_NAME.9']]
    df_share_oc = pd.melt(df_share_oc, id_vars =['PROP_ID'], value_vars =['OWNER_NAME', 'OWNER_NAME.1', 'OWNER_NAME.2', 'OWNER_NAME.3',
            'OWNER_NAME.4',  'OWNER_NAME.5', 'OWNER_NAME.6', 'OWNER_NAME.7',
            'OWNER_NAME.8', 'OWNER_NAME.9'])
    df_share_oc['variable'] = df_share_oc['variable'].replace(['OWNER_NAME', 'OWNER_NAME.1', 'OWNER_NAME.2', 'OWNER_NAME.3',
            'OWNER_NAME.4',  'OWNER_NAME.5', 'OWNER_NAME.6', 'OWNER_NAME.7',
            'OWNER_NAME.8', 'OWNER_NAME.9'], ['Share_1', 'Share_2',
                    'Share_3', 'Share_4', 'Share_5','Share_6', 'Share_7', 'Share_8', 'Share_9', 'Share_10'])
    df_share_combine = pd.merge(df_share_melted, df_share_oc, how='left', on=['PROP_ID', 'variable'])
    df_share_combine = pd.merge(df_share_combine, coord, how='left', on=['PROP_ID'])
    df_share_combine = df_share_combine.rename(columns={'value_x': 'value', 'value_y': 'OWNER_NAME'})



    # Introduce the inst owner dataset

    df_share_combine = pd.merge(df_share_combine, owner_ten, on='OWNER_NAME', how='left')

    # Correct for mining investor that are already the Ultimate Owner
    df_share_combine['1ST_INST_OWNER_NAME'] = df_share_combine['1ST_INST_OWNER_NAME'].fillna(df_share_combine['OWNER_NAME'])
    df_share_combine['1ST_INST_OWNER_PCT'] = df_share_combine['1ST_INST_OWNER_PCT'].fillna(100)

    z = df_share_combine

    #Rearrange the shares of institutional owners to 100% scale
    z = rearrange_shares(z)

    z['Share_1'] = z['value']*(z["1ST_INST_OWNER_PCT"]/100)
    z['Share_2'] = z['value']*(z["2ND_INST_OWNER_PCT"]/100)
    z['Share_3'] = z['value']*(z["3RD_INST_OWNER_PCT"]/100)
    z['Share_4'] = z['value']*(z["4TH_INST_OWNER_PCT"]/100)
    z['Share_5'] = z['value']*(z["5TH_INST_OWNER_PCT"]/100)
    z['Share_6'] = z['value']*(z["6TH_INST_OWNER_PCT"]/100)
    z['Share_7'] = z['value']*(z["7TH_INST_OWNER_PCT"]/100)
    z['Share_8'] = z['value']*(z["8TH_INST_OWNER_PCT"]/100)
    z['Share_9'] = z['value']*(z["9TH_INST_OWNER_PCT"]/100)
    z['Share_10'] = z['value']*(z["10TH_INST_OWNER_PCT"]/100)

    z_ownername = z[['PROP_ID', 'OWN_STRUCTURE']]
    z_ownername = z_ownername.drop_duplicates()

    z_inst_share = z[['PROP_ID', 'Share_1', 'Share_2',
          'Share_3', 'Share_4', 'Share_5', 'Share_6', 'Share_7', 'Share_8',
          'Share_9', 'Share_10']]

    z_inst_share = pd.melt(z_inst_share, id_vars =['PROP_ID'], value_vars =['Share_1', 'Share_2',
          'Share_3', 'Share_4', 'Share_5', 'Share_6', 'Share_7', 'Share_8',
          'Share_9', 'Share_10'])
    z_inst_share = z_inst_share.rename(columns={'variable': 'share_rank'})
    z_inst_share = z_inst_share[['PROP_ID', 'value']]

    z_inst_name = z[['PROP_ID', '1ST_INST_OWNER_NAME', '2ND_INST_OWNER_NAME',
            '3RD_INST_OWNER_NAME','4TH_INST_OWNER_NAME', '5TH_INST_OWNER_NAME',
            '6TH_INST_OWNER_NAME', '7TH_INST_OWNER_NAME', '8TH_INST_OWNER_NAME',
            '9TH_INST_OWNER_NAME', '10TH_INST_OWNER_NAME']]

    z_inst_name = pd.melt(z_inst_name, id_vars =[('PROP_ID')], value_vars =['1ST_INST_OWNER_NAME', '2ND_INST_OWNER_NAME',
            '3RD_INST_OWNER_NAME','4TH_INST_OWNER_NAME', '5TH_INST_OWNER_NAME',
            '6TH_INST_OWNER_NAME', '7TH_INST_OWNER_NAME', '8TH_INST_OWNER_NAME',
            '9TH_INST_OWNER_NAME', '10TH_INST_OWNER_NAME'])
    z_inst_name = z_inst_name.rename(columns={'variable': 'name_rank', 'value':'Financial_name'})


    z_inst_name = pd.merge(z_inst_name, country_name, on='Financial_name', how='left')
    z_inst_name["Country"] = z_inst_name["Country"].replace(["United States"], "USA")
    z_inst_name["Country"] = z_inst_name["Country"].replace(["Hong Kong"], "China")
    z_inst_name["Country"] = z_inst_name["Country"].replace(["Hong Kong"], "China")

    df_combine = pd.concat([z_inst_share, z_inst_name],  axis="columns")

    df_combine = pd.merge(df_combine, master_company, on='Financial_name', how='left', suffixes=('', '_new'))

    df_combine['Country'] = df_combine['Country'].combine_first(df_combine['Country_new'])
    df_combine.drop(columns=['Country_new'], inplace=True)
    df_combine['Country'] = df_combine.apply(lambda row: fill_missing_countries(row, missing_countries), axis=1)



    test = df_combine.groupby('Country')['value'].sum().reset_index()

    test['total'] = test['value']/test['value'].sum() * 100
    test['HHI'] = test['total'] * test['total']
    mineral_name = re.sub(r'\.xlsx$', '', element)
    test['mineral'] =mineral_name
    test = test.sort_values(by='HHI', ascending=False)
    dfs.append(test)
  except:
    pass
hhi_soc_res = pd.concat(dfs, ignore_index=True)
hhi_soc_res = hhi_soc_res.groupby(['mineral', 'Country'])['HHI'].sum().reset_index()
hhi_soc_res = hhi_soc_res.sort_values(by='HHI', ascending=False)
hhi_soc_res = hhi_soc_res[~hhi_soc_res.mineral.isin(mineral_filter)]

"""## Get des stats"""

table_df_reserves_geo = hhi_geo_res.loc[hhi_geo_res['COUNTRY_NAME'] == "All"]
table_df_reserves_geo = table_df_reserves_geo.loc[table_df_reserves_geo['HHI_reserves'] > 0]
table_df_reserves_geo = table_df_reserves_geo.rename(columns={'HHI_reserves': 'HHI (geographic)'})
table_df_reserves_geo = table_df_reserves_geo[['Mineral','HHI (geographic)']]

table_df_reserves_lo = hhi_lo_res.loc[hhi_lo_res['OWNER_COUNTRY'] == "All"]
table_df_reserves_lo = table_df_reserves_lo.loc[table_df_reserves_lo['HHI_reserves'] > 0]
table_df_reserves_lo = table_df_reserves_lo.rename(columns={'HHI_reserves': 'HHI (legal origin)'})
table_df_reserves_lo = table_df_reserves_lo[['Mineral','HHI (legal origin)']]

#table_df_production_soc = hhi_soc_df.loc[hhi_soc_df['Country'] == "All"]
table_df_reserves_soc = hhi_soc_res.loc[hhi_soc_res['HHI'] > 0]
table_df_reserves_soc = table_df_reserves_soc.groupby(['mineral'])['HHI'].sum().reset_index()
table_df_reserves_soc = table_df_reserves_soc.sort_values(by=['HHI'], ascending=True)
table_df_reserves_soc = table_df_reserves_soc.rename(columns={'mineral': 'Mineral', 'HHI': 'HHI (SOC)'})

table_df_reserves_combine = pd.merge(table_df_reserves_geo, table_df_reserves_lo, on='Mineral', how='left')
table_df_reserves_combine = pd.merge(table_df_reserves_combine, table_df_reserves_soc, on='Mineral', how='left')
table_df_reserves_combine['Diff LO/GEO'] = (table_df_reserves_combine['HHI (legal origin)'] - table_df_reserves_combine['HHI (geographic)']) / table_df_reserves_combine['HHI (geographic)'] * 100
table_df_reserves_combine['Diff SOC/GEO'] = (table_df_reserves_combine['HHI (SOC)'] - table_df_reserves_combine['HHI (geographic)']) / table_df_reserves_combine['HHI (geographic)'] * 100
table_df_reserves_combine[['HHI (geographic)', 'HHI (legal origin)', 'HHI (SOC)', 'Diff LO/GEO', 'Diff SOC/GEO' ]] = table_df_reserves_combine[['HHI (geographic)', 'HHI (legal origin)', 'HHI (SOC)', 'Diff LO/GEO', 'Diff SOC/GEO']].astype(int)
table_df_reserves_combine = table_df_reserves_combine.sort_values(by=['Mineral'], ascending=True)
table_df_reserves_combine

table_df_reserves_combine.to_excel("./Tables/table_df_reserves_combine.xlsx")

"""### HHI decomposition GEO"""

hhi_geo_res = hhi_geo_res.sort_values(by=['HHI_reserves'], ascending=True)
HHI_agregated = hhi_geo_res.loc[hhi_geo_res['COUNTRY_NAME'] != "All"]
HHI_agregated['COUNTRY_NAME'] = HHI_agregated['COUNTRY_NAME'].replace(country_list,'Other countries')
HHI_agregated = HHI_agregated.loc[HHI_agregated['HHI_reserves'] > 0]
#HHI_agregated['COUNTRY_NAME'] = HHI_agregated['COUNTRY_NAME'].replace(country_list,'Other countries')
HHI_agregated = HHI_agregated.groupby(["Mineral", "COUNTRY_NAME"])["HHI_reserves"].sum()
HHI_agregated = HHI_agregated.reset_index()
HHI_agregated = HHI_agregated.sort_values(by=['HHI_reserves'], ascending=True)



fig = px.bar(HHI_agregated, y='Mineral', x='HHI_reserves', orientation='h', color="COUNTRY_NAME", color_discrete_map=color_map_alter, text="COUNTRY_NAME",labels={
                     "HHI_reserves": "Production (HHI)",
                     "COUNTRY_NAME": "Country (host)"},
                title="Manually Specified Labels")
fig.update_layout(yaxis={"dtick":1},margin={"t":0,"b":0},height=500)
fig.update_yaxes(categoryorder='category descending')
fig.update_layout(
    legend_title='Type',
    template='plotly_white',  # Use a cleaner theme
    width=1200,  # Adjust the width
    height=800,  # Adjust the height
)

fig.write_image("./Graphs/Figure11.png")

"""### HHI decomposition LO"""

hhi_lo_res = hhi_lo_res.sort_values(by=['HHI_reserves'], ascending=True)
HHI_agregated = hhi_lo_res.loc[hhi_lo_res['OWNER_COUNTRY'] != "All"]
HHI_agregated['OWNER_COUNTRY'] = HHI_agregated['OWNER_COUNTRY'].replace(country_list,'Other countries')
HHI_agregated = HHI_agregated.groupby(["Mineral", "OWNER_COUNTRY"])["HHI_reserves"].sum()
HHI_agregated = HHI_agregated.reset_index()
HHI_agregated = HHI_agregated.sort_values(by=['HHI_reserves'], ascending=True)
fig = px.bar(HHI_agregated, y='Mineral', x='HHI_reserves', orientation='h', color="OWNER_COUNTRY", color_discrete_map=color_map_alter, text="OWNER_COUNTRY",labels={
                     "HHI_reserves": "Production (HHI)",
                     "OWNER_COUNTRY": "Owner (country)"},
                title="Manually Specified Labels")
fig.update_layout(yaxis={"dtick":1},margin={"t":0,"b":0},height=500)
fig.update_yaxes(categoryorder='category descending')
fig.update_layout(
    legend_title='Type',
    template='plotly_white',  # Use a cleaner theme
    width=1200,  # Adjust the width
    height=800,  # Adjust the height
)
fig.write_image("./Graphs/Figure12.png")

"""### HHI decomposition SOC"""

hhi_soc_res = hhi_soc_res.sort_values(by=['HHI'], ascending=True)
HHI_agregated = hhi_soc_res.loc[hhi_soc_res['Country'] != "All"]
HHI_agregated['Country'] = HHI_agregated['Country'].replace(country_list_bolivia,'Other countries')
HHI_agregated = HHI_agregated.groupby(["mineral", "Country"])["HHI"].sum()
HHI_agregated = HHI_agregated.reset_index()
HHI_agregated = HHI_agregated.sort_values(by=['HHI'], ascending=True)
fig = px.bar(HHI_agregated, y='mineral', x='HHI', orientation='h', color="Country", color_discrete_map=color_map_alter, text="Country",labels={
                     "HHI": "Production (HHI)",
                     "Country": "Owner (country)"},
                title="Manually Specified Labels")
fig.update_layout(yaxis={"dtick":1},margin={"t":0,"b":0},height=500)
fig.update_yaxes(categoryorder='category descending')
fig.update_layout(
    legend_title='Type',
    template='plotly_white',  # Use a cleaner theme
    width=1200,  # Adjust the width
    height=800,  # Adjust the height
)

fig.write_image("./Graphs/Figure13.png")
